
	opt d+

heat	SEGMENT at 8000h


;KONIX PDS Downloader
;By S.Ahmad 27/2/89



;PDS equates
RBLK	EQU	3E0H	;register block


	ASSUME CS:heat


;Slipstream Hardware Definitions
;This version is for the 8088 prototypes only

; The IO space

; Video controller locations
INTL		equ	00h
INTH		equ	01h
STARTL		equ	02h
STARTH		equ	03h
HCNTL		equ	04h
HCNTH		equ	05h
VCNTL		equ	06h
VCNTH		equ	07h
SCROLL1		equ	08h
SCROLL2		equ	09h
SCROLL3		equ	0Ah
ACK		equ	0Bh
MODE		equ	0Ch
BORDL		equ	0Dh
BORDH		equ	0Eh
PMASK		equ	0Fh
INDEX		equ	10h
ENDL		equ	11h
ENDH		equ	12h
MEM		equ	13h
GPR		equ	14h
DIAG		equ	15h
DIS		equ	16h
HLPL		equ	00h
HLPH		equ	01h
VLPL		equ	02h
VLPH		equ	03h
STATUS		equ	04h

; Blitter locations
BLPROG0		equ	30h
BLPROG1		equ	31h
BLPROG2		equ	32h
BLCMD		equ	33h
BLCON		equ	34h
BLDEST0		equ	20h
BLDEST1		equ	21h
BLDEST2		equ	22h
BLSRC0		equ	23h
BLSRC1		equ	24h
BLSRC2		equ	25h
BLSTAT		equ	26h
BLINNER		equ	27h
BLOUTER		equ	28h

; External IO
PORT1		equ	40h
PORT2		equ	50h
PORT3		equ	40h

; Expansion IO base locations
GPIO0		equ	60h
GPIO1		equ	70h


; Blitter Command Definition
BL_SRC0		equ	0
BL_SRC1		equ	1
BL_SRC2		equ	2
BL_DST0		equ	3
BL_DST1		equ	4
BL_DST2		equ	5
BL_MODE		equ	6
BL_CMPL		equ	7
BL_OUT		equ	8
BL_IN		equ	9
BL_STEP		equ	10
BL_PAT		equ	11
BL_CMD		equ	12

;Z8536 equates
DRC	EQU	60H
DRB	EQU	61H
DRA	EQU	62H
CTRL	EQU	63H



BORDER	MACRO	BC
	PUSH	AX
	MOV	AX,BC
	OUT	BORDL,AX
	POP	AX
	ENDM


; Start of program
START	MOV	AX,CS
	MOV	DS,AX
	XOR	AX,AX	;crude
	MOV	SS,AX	;but what's a null stack segment between friends?
	MOV	SP,3E0H	;stack at top of INT vector table
	CLD

PDS:	CALL	SSINIT	;initialise the Slipstream
	CALL	Z8536INIT	;initialise the Z8536 chip


	IN	AL,DRC
	AND	AL,2
	JNZ	PDSf
	MOV	AL,1
	OUT	13H,AL
	MOV	AX,8000H
	DB	0EAH,7,0,0,0FCH

PDSF:	MOV	DX,DRC		;set ptr to DRC
	MOV	BX,0800H		;FLAG in BL, pc3 mask in BH

PDSLOOP:	INC	AH	;increment red value
	MOV	AL,AH	;get it
	OUT	BORDH,AL	;change red value in hardware
	IN	AL,DRC	;Get from port C
	XOR	AL,BL	;FLAG is in BL
	AND	AL,BH	;is PC ready?
	JNZ	PDSLOOP	;go back and wait

	XOR	AL,AL	;reset the border
	OUT	BORDL,AL	;to
	OUT	BORDH,AL	;black

	CALL	GETBYTE2	;get the byte made available on port A
	SUB	AL,200	;minimum command value
	JC	PDSLOOP	;if less than this, ignore it
	JNZ	PL0
;200 download
	CALL	GETMEM
	JMP	PDSLOOP
PL0:	DEC	AL
	JNZ	PL1
;201 upload
	CALL	SENDMEM
	JMP	PDSLOOP
PL1:	DEC	AL
	JNZ	PL2
;202 run
	PUSH	BX
	PUSH	DX
	MOV	AX,CS		;push code seg
	PUSH	AX
	MOV	AX,OFFSET CS:PL3	;push displacement
	PUSH	AX
	CALL	GETWORD		;get seg
	PUSH	AX
	CALL	GETWORD		;get offset
	PUSH	AX
	CALL	LOADREGS		;get the register block before running
	RETF
PL3:	CALL	SAVEREGS
	MOV	AX,CS
	MOV	DS,AX
	POP	DX
	POP	BX
	JMP	PDSLOOP

PL2:	SUB	AL,4
	JNZ	PL4
;206 send register block to host
	CALL	SENDREGS
	JMP	PDSLOOP

PL4:	DEC	AL
	JNZ	PL5
;207 get register block from host
	CALL	GETREGS

PL5:	JMP	PDSLOOP


;Enter both these routines with DX=60h, BL=FLAG and BH=8
;Get a word of data from the PC, high byte first
GETWORD:	CALL	GETBYTE	;get the low byte
	MOV	AH,AL	;save it, get high byte in AL
	CALL	GETBYTE
	XCHG	AH,AL	;get them right way round
	RET

;Get a byte of data from the PC
GETBYTE:	IN	AL,DRC	;Get from port C
	XOR	AL,BL	;FLAG is in BL
	AND	AL,BH	;is PC ready?
	JNZ	GETBYTE	;go back and wait

GETBYTE2:	IN	AL,DRA	;get the byte from the PC from DRA
	PUSH	AX	;save it
	IN	AL,DRC	;get from port C again, (1's in high nybble)
	XOR	AL,4	;change the output bit
	AND	AL,0BFH	;remove protect bit for output
	OUT	DRC,AL	;tell PC we've got the byte
	XOR	BL,BH	;change the strobing value
	POP	AX	;get the byte in AL
	RET


GETREGS:	XOR	AX,AX
	MOV	ES,AX
	MOV	DI,3E0H
	MOV	CX,28	;13 words of regblock
	JMP	SHORT GR0

;Get a block of memory from the PC
;Note that no more than 32k at a time is ever sent, but that an offset sent
;by the PC could wrap around in memory, this isn't detected, since the user
;is assumed to know what's going on, PDS shouldn't allow it anyway.
GETMEM:	CALL	GETWORD	;get the segment
	MOV	ES,AX	;set segment ptr
	CALL	GETWORD	;get the offset
	MOV	DI,AX	;set offset ptr
	CALL	GETWORD	;discard high word of length
	CALL	GETWORD	;get word of length
	MOV	CX,AX	;set count

GR0:	BORDER 0FH	;blue border to show we're downloading

	AND	BL,BL	;is flag set?
	JNZ	GETMEM1	;yes, do other loop
GETMEM0:	IN	AL,DX	;Get from port C
	TEST	AL,BH	;is PC ready?
	JNZ	GETMEM0	;wait until it is
	IN	AL,62H	;get the byte from the PC
	MOV	[SI],AL
	STOSB		;save it to RAM
	IN	AL,DX	;get from port C again
	XOR	AL,44H	;change the output bit and strip the protect bit
	OUT	DX,AL	;tell PC we've got the byte
	LOOP	GETMEM1	;loop to other half of download

	MOV	BL,BH	;flag should be set on exit from this loop
	RET		;all done
GETMEM1:	IN	AL,DX	;Get from port C
	TEST	AL,BH	;is PC ready?
	JZ	GETMEM1	;wait until it is
	IN	AL,62H	;get the byte from the PC
	MOV	[SI],AL
	STOSB		;save it to RAM
	IN	AL,DX	;get from port C again
	XOR	AL,44H	;change the output bit and strip the protect bit
	OUT	DX,AL	;tell PC we've got the byte
	LOOP	GETMEM0	;loop to other half of download

	XOR	BL,BL	;flag should be clear on exit from this loop
	RET		;all done


LOADREGS:	MOV	AX,word ptr SS:[RBLK+10]
	MOV	DS,AX
	MOV	AX,word ptr SS:[RBLK+12]
	MOV	ES,AX
	MOV	BP,word ptr SS:[RBLK+16]
	MOV	SI,word ptr SS:[RBLK+18]
	MOV	DI,word ptr SS:[RBLK+20]
	MOV	AX,word ptr SS:[RBLK]
	MOV	BX,word ptr SS:[RBLK+2]
	MOV	CX,word ptr SS:[RBLK+4]
	MOV	DX,word ptr SS:[RBLK+24]
	PUSH DX
	POPF
	MOV	DX,word ptr SS:[RBLK+6]
	RET


SAVEREGS:	MOV	word ptr SS:[RBLK+16],BP
	MOV	word ptr SS:[RBLK+18],SI
	MOV	word ptr SS:[RBLK+20],DI
	MOV	word ptr SS:[RBLK],AX
	MOV	word ptr SS:[RBLK+2],BX
	MOV	word ptr SS:[RBLK+4],CX
	MOV	word ptr SS:[RBLK+6],DX
	PUSHF
	POP	AX
	MOV	word ptr SS:[RBLK+24],AX
	MOV	AX,DS
	MOV	word ptr SS:[RBLK+10],AX
	MOV	AX,ES
	MOV	word ptr SS:[RBLK+12],AX
	RET

SENDREGS:	PUSH	DS
	XOR	AX,AX
	MOV	DS,AX
	MOV	SI,3E0H
	MOV	CX,28	;14 words of regblock
	JMP	SHORT SR0

SENDMEM:	PUSH	DS
	CALL	GETWORD	;get the segment
	MOV	DS,AX	;set segment ptr
	CALL	GETWORD	;get the offset
	MOV	SI,AX	;set offset ptr
	CALL	GETWORD	;discard high word of length
	CALL	GETWORD	;get word of length
	MOV	CX,AX	;Set count

SR0:	BORDER 0F0H	;green border to show we're uploading

SWPMEM0:	IN	AL,DX	;Get from port C
	XOR	AL,BL	;FLAG is in BL
	AND	AL,BH	;is PC ready?
	JNZ	SWPMEM0	;go back and wait

	XOR	BL,BH	;change the strobing value

	MOV	AL,23H	;DDRA
	OUT	CTRL,AL	;set the address
	XOR	AL,AL	;0 for outputs
	OUT	CTRL,AL	;port A set for output now

SENDMEM0:	MOV	AL,[SI]
	LODSW		;get a byte from Slipstream RAM
	DEC	SI
	OUT	DRA,AL	;stick it on the port
	IN	AL,DX	;get from port C again
	XOR	AL,4	;change the output bit
	AND	AL,0BFH	;strip protect bit for output
	OUT	DX,AL	;tell PC byte is ready

SENDMEM1:	IN	AL,DX	;Get from port C
	XOR	AL,BL	;FLAG is in BL
	AND	AL,BH	;is PC ready?
	JNZ	SENDMEM1	;go back and wait
	XOR	BL,BH	;change the strobing value
	LOOP	SENDMEM0	;keep going until counter expires

	MOV	AL,23H	;DDRA
	OUT	CTRL,AL	;set address
	MOV	AL,0FFH	;ffh for input
	OUT	CTRL,AL	;set port A for input

	IN	AL,DX	;get from port C again
	XOR	AL,4	;change the output bit
	AND	AL,0BFH	;strip protect bit for output
	OUT	DX,AL	;tell PC to swap back ports

	POP	DS
	RET		;memory received, quit.



;Initialise the Z8536 from a table
Z8536INIT:	MOV	SI,OFFSET ds:CPORTTAB
	IN	AL,CTRL	;force chip into known state
	XOR	AL,AL
	OUT	CTRL,AL

Z80:	LODSW
	AND	AL,AL
	JS	Z81	;end of control list
	OUT	CTRL,AL
	MOV	AL,AH	;get value to write
	OUT	CTRL,AL
	JMP	Z80
Z81:	RET



;This procedure initialises the Slipstream system
ssinit:	xor	al,al		; set a block border
	out	BORDL,al
	out	BORDH,al

	xor	al,al		; set the screen start to line 20h
	out	starth,al
	inc	al		;20h
	out	startl,al

	dec	al		; and the end to make it 200 lines
	out	endh,al
	mov	al,02		; End should be 0E8h
	out	endl,al

	dec	al
	out 	MEM,al		; set dRAM at 80000h

	dec	al		; make the screen start at 1K
	out	SCROLL1,al
	mov	al,4
	out	SCROLL2,al
	xor	al,al
	out	SCROLL3,al

	inc	al		; medium res
	out	MODE,al
	dec	al
	out	PMASK,al		; clear mask
	out	INDEX,al		; clear index
; Initialise the interrupt table with 256 pointers to a return instruction
;	mov	cx,256			; do all 256 interrupts
;	mov	bx,0			; address pointer
;	push	ds			; save current data segment
;	mov	ds,bx			; and point ds at 0
;	mov	ax,offset intser	; ax is address of dummy ISR
;st1:	mov	ds:[bx],ax		; set up IP
;	add	bx,2
;	mov	ds:[bx],cs		; set up CS
;	add	bx,2
;	loop	st1			; do them all
;	pop	ds			; and restore CS
; Initialise the bottom 16 elements of the palette with a grey scale
	push	ds
	mov	ax,4000h
	mov	ds,ax
	MOV	BYTE PTR DS:1600H,0		;turn run bit off

	mov	bx,0
st2:	mov	ah,bl
	shr	ah,1
	mov	al,bl
	shl	al,1
	shl	al,1
	shl	al,1
	or	al,ah
	mov	[bx],al
	inc	bx
	mov	[bx],al
	inc	bx
	cmp	bx,32
	jnz	st2
	pop	ds
; Disable all interrupts in video hardware and enable CPU interrupts
	mov	al,0Fh
	out	DIS,al
	out	ACK,al
	sti
; Mask interrupts in the blitter
	mov	al,01h
	out	BLCON,al
	ret


; Blitter program to clear a 200 line screen starting at $400
	even
bcls	equ	$
	DB	0,0,0
	DB	0,4,0
	DB	022h			; mode
	DB	0C0h			; LFU and comp
	DB	200			; outer count
	DB	0			; inner count
	DB	0			; step
	DB	0			; pattern
	DB	0			; next command


; Default interrupt service routine
intser:	out	ACK,al			; clear interrupt hardware
	iret				; return from interrupt



;End of program
FINISH:	MOV	AX,4C00H
	INT	21H

	EVEN
CPORTTAB	DB	1,0
	DB	1,14H
	DB	20H,10H
	DB	21H,0
	DB	8,0E0H
	DB	22H,0
	DB	5,0
	DB	23H,0FFH
	DB	6,8+2
	DB	24H,0
	DB	7,0
	DB	15,0B4H

	DB	-1,-1	;terminator

RUNADDR	DW	0,0

heat	ENDS

	end start

